/*
 * gsampler-console.h
 * Copyright (C) Lilian Monchalin 2011 <isaya07@users.sf.net>
 *
 * gsampler is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * gsampler is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _GSAMPLER_CONSOLE_H_
#define _GSAMPLER_CONSOLE_H_

#include <gtk/gtk.h>

G_BEGIN_DECLS

#define GSAMPLER_TYPE_CONSOLE (gsampler_console_get_type ())
#define GSAMPLER_CONSOLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GSAMPLER_TYPE_CONSOLE, GsamplerConsole))
#define GSAMPLER_CONSOLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GSAMPLER_TYPE_CONSOLE, GsamplerConsoleClass))
#define GSAMPLER_IS_CONSOLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GSAMPLER_TYPE_CONSOLE))
#define GSAMPLER_IS_CONSOLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GSAMPLER_TYPE_CONSOLE))
#define GSAMPLER_CONSOLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GSAMPLER_TYPE_CONSOLE, GsamplerConsoleClass))
#define GSAMPLER_CONSOLE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GSAMPLER_TYPE_CONSOLE, GsamplerConsolePrivate))

typedef struct _GsamplerConsole GsamplerConsole;
typedef struct _GsamplerConsoleClass GsamplerConsoleClass;
typedef struct _GsamplerConsolePrivate GsamplerConsolePrivate;

struct _GsamplerConsole {
	GtkNotebook parent_instance;
	GsamplerConsolePrivate * priv;
};

struct _GsamplerConsoleClass {
	GtkNotebookClass parent_class;
};

struct _GsamplerConsolePrivate {
	GtkTextBuffer* buffer;
	GtkTextBuffer* server_buffer;
	GtkWindow* window;
	GtkTextView*  eventoutput;
	GtkTextView*  server_output;
	GtkWidget* send_com;
	gulong send_com_id;
	GString *console_mes;
};

GType gsampler_console_get_type (void) G_GNUC_CONST;
GsamplerConsole* gsampler_console_new (void);

void gsampler_console_push_event (GsamplerConsole* self, const gchar* message, gpointer data);
void gsampler_console_push_server_event (GsamplerConsole* self, const gchar* message, gpointer data);
void gsampler_console_active (GsamplerConsole* self);
void gsampler_console_inactive (GsamplerConsole* self);

G_END_DECLS

#endif /* _GSAMPLER_CONSOLE_H_ */
